#include "PX_Game.h"
px_void PX_Game_MP_ErrorCall(px_void* ptr, PX_MEMORYPOOL_ERROR err)
{
	return;
}
px_bool PX_GameInitialize(PX_Runtime* runtime,px_memorypool* mp, PX_Game* pgame, PX_FontModule* fm)
{
	PX_memset(pgame, 0, sizeof(PX_Game));
	pgame->mp = mp;
	pgame->fm = fm;
	pgame->state = PX_GAME_STATE_END;
	pgame->mp_runtime = MP_Create(MP_Malloc(mp, PX_OBJECT_GAME_RUNTIME), PX_OBJECT_GAME_RUNTIME);
	pgame->runtime = runtime;
	if (!PX_WorldInitialize(&pgame->mp_runtime, &pgame->world, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, \
		PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, 1024 * 128))
	{
		return PX_FALSE;
	}
	PX_WorldSetAuxiliaryLineColor(&pgame->world, PX_COLOR(0, 0, 0, 0));

	return PX_TRUE;
}

px_bool PX_GameStart(PX_Game* pgame, PX_GameInstanceData* pdata1, PX_GameInstanceData* pdata2)
{
	MP_Reset(&pgame->mp_runtime);
	if (!PX_WorldInitialize(&pgame->mp_runtime, &pgame->world, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, \
		PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, 1024 * 128))
	{
		return PX_FALSE;
	}
	PX_WorldSetAuxiliaryLineColor(&pgame->world, PX_COLOR(0, 0, 0, 0));

	pgame->pobject_map = PX_Object_MapCreate(&pgame->mp_runtime, 0, 0, 0, PX_OBJECT_MAP_Z);
	PX_WorldAddObject(&pgame->world, pgame->pobject_map);

	pgame->mp_botred = MP_Create(MP_Malloc(&pgame->mp_runtime, PX_OBJECT_BOT_RUNTIME_SIZE), PX_OBJECT_BOT_RUNTIME_SIZE);
	MP_ErrorCatch(&pgame->mp_botred, PX_Game_MP_ErrorCall, pgame);
	pgame->mp_botblue = MP_Create(MP_Malloc(&pgame->mp_runtime, PX_OBJECT_BOT_RUNTIME_SIZE), PX_OBJECT_BOT_RUNTIME_SIZE);
	MP_ErrorCatch(&pgame->mp_botblue, PX_Game_MP_ErrorCall, pgame);

	pgame->pobject_botred = PX_Object_RobotCreate(&pgame->mp_botred,pgame->runtime, 0, PX_Object_MapIndexToCoordinate(0), PX_Object_MapIndexToCoordinate(0),&pgame->world,
		PX_OBJECT_ROBOT_TYPE_RED, pdata1, pgame->pobject_map, pgame->fm);


	pgame->pobject_botblue = PX_Object_RobotCreate(&pgame->mp_botblue, pgame->runtime, 0, PX_Object_MapIndexToCoordinate(PX_OBJECT_MAP_SIZE-1), PX_Object_MapIndexToCoordinate(PX_OBJECT_MAP_SIZE - 1), &pgame->world,
		PX_OBJECT_ROBOT_TYPE_BLUE, pdata2, pgame->pobject_map, pgame->fm);
	if (pgame->pobject_botred ==0&& pgame->pobject_botblue==0)
	{
		pgame->state = PX_GAME_STATE_END;
		pgame->result = PX_GAME_RESULT_TIE;
	}
	else if (pgame->pobject_botred == 0)
	{
		pgame->state = PX_GAME_STATE_END;
		pgame->result = PX_GAME_RESULT_BLUEWIN;
	}
	else if (pgame->pobject_botblue==0)
	{
		pgame->state = PX_GAME_STATE_END;
		pgame->result = PX_GAME_RESULT_REDWIN;
	}
	else
	{
		PX_WorldAddObject(&pgame->world, pgame->pobject_botblue);
		PX_WorldAddObject(&pgame->world, pgame->pobject_botred);
		pgame->state = PX_GAME_STATE_RUN;
	}

	pgame->time = PX_OBJETC_GAME_TIME;

	return PX_TRUE;
}

PX_GAME_RESULT PX_GameRunTest(px_memorypool *mp, PX_GameInstanceData* pdata1, PX_GameInstanceData* pdata2)
{
	PX_Game game;
	
	if (PX_GameInitialize(PX_NULL,mp, &game, 0))
	{
		if (PX_GameStart(&game, pdata1, pdata2))
		{
			PX_GAME_RESULT result;
			while (game.state == PX_GAME_STATE_RUN)
			{
				PX_GameUpdate(&game, PX_GAME_TIME_GRANULARITY);
			}
			
			result = game.result;
			PX_GameFree(&game);
			return result;
		}
	}
	return PX_GAME_RESULT_UNKNOW;
}

px_void PX_GameUpdate(PX_Game* pgame, px_dword elapsed)
{
	switch (pgame->state)
	{
	case PX_GAME_STATE_RUN:
	{
		px_int i, j;
		pgame->update_elapsed += elapsed;
		while (pgame->update_elapsed >= PX_GAME_TIME_GRANULARITY)
		{
			PX_WorldUpdate(&pgame->world, PX_GAME_TIME_GRANULARITY);
			pgame->update_elapsed -= PX_GAME_TIME_GRANULARITY;
		}

		pgame->red = 0;
		pgame->blue = 0;
		for (i = 0; i < PX_OBJECT_MAP_SIZE; i++)
		{
			for (j = 0; j < PX_OBJECT_MAP_SIZE; j++)
			{
				PX_OBJECT_MAP_CELL c = PX_Object_MapGetCell(pgame->pobject_map, i, j);
				if (c == PX_OBJECT_MAP_CELL_RED)
				{
					pgame->red++;
				}
				if (c == PX_OBJECT_MAP_CELL_BLUE)
				{
					pgame->blue++;
				}
			}
		}

		//result 1
		do 
		{
			PX_Object_Robot* pbot1 = PX_ObjectGetDesc(PX_Object_Robot, pgame->pobject_botred);
			PX_Object_Robot* pbot2 = PX_ObjectGetDesc(PX_Object_Robot, pgame->pobject_botblue);

			if (pbot1->death || pbot2->death)
			{
				PX_WorldUpdate(&pgame->world, 0);
				if (pbot1->death && pbot2->death)
				{
					pgame->state = PX_GAME_STATE_END;
					pgame->result = PX_GAME_RESULT_TIE;
				}
				else if (pbot1->death)
				{
					pgame->state = PX_GAME_STATE_END;
					pgame->result = PX_GAME_RESULT_BLUEWIN;
				}
				else
				{
					pgame->state = PX_GAME_STATE_END;
					pgame->result = PX_GAME_RESULT_REDWIN;
				}
				break;
			}

			

			if (pgame->time > elapsed)
			{
				pgame->time -= elapsed;
			}
			else
			{
				pgame->time = 0;
				pgame->state = PX_GAME_STATE_END;
				PX_WorldUpdate(&pgame->world, 0);
				if (pgame->red>pgame->blue)
				{
					pgame->result = PX_GAME_RESULT_REDWIN;
				}
				else if (pgame->blue > pgame->red)
				{
					pgame->result = PX_GAME_RESULT_BLUEWIN;
				}
				else
				{
					pgame->result = PX_GAME_RESULT_TIE;
				}
				PX_WorldUpdate(&pgame->world, 0);
			}

		} while (0);
	}
	break;
	case PX_GAME_STATE_END:
	{

	}
	break;
	}
	
	
}

px_void PX_GameRender(px_surface* prendersurface, PX_Game* pgame, px_dword elapsed)
{
		PX_WorldRender(prendersurface, &pgame->world, elapsed);
}

px_void PX_GameFree(PX_Game* pgame)
{
	MP_Free(pgame->mp, pgame->mp_runtime.StartAddr);
}

