#ifndef PX_GAME_H
#define PX_GAME_H
#include "PX_Object_Robot.h"
#include "PX_GameInstanceData.h"

#define  PX_GAME_TIME_GRANULARITY 50
#define PX_OBJECT_GAME_RUNTIME 1024*1024*8
#define PX_OBJETC_GAME_TIME 256000
#define PX_OBJECT_BOT_RUNTIME_SIZE (1024*1024*2)
typedef enum 
{
	PX_GAME_STATE_RUN,
	PX_GAME_STATE_END,
}PX_GAME_STATE;

typedef enum
{
	PX_GAME_RESULT_UNKNOW,
	PX_GAME_RESULT_REDWIN,
	PX_GAME_RESULT_BLUEWIN,
	PX_GAME_RESULT_TIE,
}PX_GAME_RESULT;

typedef struct  
{
	PX_GAME_STATE state;
	PX_GAME_RESULT result;
	PX_FontModule* fm;
	PX_Runtime* runtime;
	px_memorypool* mp;
	px_memorypool mp_runtime;
	px_memorypool mp_botred;
	px_memorypool mp_botblue;
	PX_Object* pobject_map;
	PX_Object* pobject_botred;
	PX_Object* pobject_botblue;
	px_dword update_elapsed;
	px_dword time;
	px_dword end_wait;
	px_int red, blue;
	PX_World world;
}PX_Game;


px_bool PX_GameInitialize(PX_Runtime* runtime,px_memorypool* mp, PX_Game *pgame, PX_FontModule* fm);
px_bool PX_GameStart(PX_Game* pgame, PX_GameInstanceData* pdata1, PX_GameInstanceData* pdata2);
PX_GAME_RESULT PX_GameRunTest(px_memorypool* mp, PX_GameInstanceData* pdata1, PX_GameInstanceData* pdata2);
px_void PX_GameUpdate(PX_Game* pgame, px_dword elapsed);
px_void PX_GameRender(px_surface* prendersurface, PX_Game* pgame, px_dword elapsed);
px_void PX_GameFree(PX_Game* pgame);

#endif