#ifndef PX_GAMEINSTANCEDATA_H
#define PX_GAMEINSTANCEDATA_H

#include "architecture/PainterEngine.h"

#define PX_GAMEINSTANCEDATA_CONTENT_SIZE 32
#define PX_GAMEINSTANCEDATA_MAX 1024

#define PX_GAMEINSTANCEDATA_CODESIZE (16 * 1024)
#define PX_GAMEINSTANCEDATA_BINSIZE (32 * 1024)
typedef struct
{
	px_char name[PX_GAMEINSTANCEDATA_CONTENT_SIZE];
	px_char author[PX_GAMEINSTANCEDATA_CONTENT_SIZE];
	px_char key[PX_GAMEINSTANCEDATA_CONTENT_SIZE];
	px_byte profile_data[48 * 48 * 4];
	px_byte code[16 * 1024];
	px_byte bin[16*1024];
	px_int  binsize;
	px_int32  match, win;
	px_float32 score;
	px_dword  dummy[256];
	px_dword  crc32;
}PX_GameInstanceDataOld;

typedef struct
{
	px_char name[PX_GAMEINSTANCEDATA_CONTENT_SIZE];
	px_char author[PX_GAMEINSTANCEDATA_CONTENT_SIZE];
	px_char key[PX_GAMEINSTANCEDATA_CONTENT_SIZE];
	px_byte profile_data[48 * 48 * 4];
	px_byte code[PX_GAMEINSTANCEDATA_CODESIZE];
	px_byte bin[PX_GAMEINSTANCEDATA_BINSIZE];
	px_int  binsize;
	px_int32  match, win;
	px_float32 score;
	px_dword seed;
	px_dword  dummy[255];
	px_dword  crc32;
}PX_GameInstanceData;

px_int PX_GameInstanceDataGetCount();
PX_GameInstanceData* PX_GameInstanceDataGetPtr();
PX_GameInstanceData* PX_GameInstanceDataGetLocalPtr();


#endif

