#include "PX_Object_Map.h"

px_void PX_Object_MapRender(px_surface* psurface, PX_Object* pObject, px_dword elapsed)
{
	px_float objx, objy, objw, objh;
	px_int i,j;
	PX_Object_Map* pdesc = PX_ObjectGetDesc(PX_Object_Map, pObject);
	PX_OBJECT_INHERIT_CODE(pObject,objx, objy, objw, objh);

	for (i=0;i< PX_OBJECT_MAP_SIZE;i++)
	{
		for (j = 0; j < PX_OBJECT_MAP_SIZE; j++)
		{
			px_color clr;
			switch (pdesc->cells[i][j])
			{
			case PX_OBJECT_MAP_CELL_NONE:
				clr = PX_COLOR_WHITE;
				break;
			case PX_OBJECT_MAP_CELL_RED:
				clr = PX_COLOR(64, 255, 0, 0);
				break;
			case PX_OBJECT_MAP_CELL_BLUE:
				clr = PX_COLOR(64, 0, 0, 255);
				break;
			case PX_OBJECT_MAP_CELL_BLACK:
				clr = PX_COLOR(255, 0, 0, 0);
				break;
				default:
					break;
			}
			
			PX_GeoDrawRect(psurface,
				(px_int)objx + i * PX_OBJECT_CELL_PIXELS,\
				(px_int)objy + j * PX_OBJECT_CELL_PIXELS,\
				(px_int)objx + i * PX_OBJECT_CELL_PIXELS + PX_OBJECT_CELL_PIXELS,\
				(px_int)objy + j * PX_OBJECT_CELL_PIXELS + PX_OBJECT_CELL_PIXELS,\
				clr);
		}
	}

	for (i = 0; i <=PX_OBJECT_MAP_SIZE; i++)
	{
		PX_GeoDrawLine(psurface, (px_int)objx + i * PX_OBJECT_CELL_PIXELS, (px_int)objy, (px_int)objx + i * PX_OBJECT_CELL_PIXELS, (px_int)objy + PX_OBJECT_CELL_PIXELS * PX_OBJECT_MAP_SIZE,1,PX_COLOR_BLACK);
	}

	for (j = 0; j <= PX_OBJECT_MAP_SIZE; j++)
	{
		PX_GeoDrawLine(psurface, (px_int)objx , (px_int)objy + j * PX_OBJECT_CELL_PIXELS, (px_int)objx + PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, (px_int)objy + j*PX_OBJECT_CELL_PIXELS, 1, PX_COLOR_BLACK);
	}

}

PX_Object* PX_Object_MapCreate(px_memorypool* mp,PX_Object *parent,px_float x,px_float y, px_float z)
{
	PX_Object_Map map = { 0 };
	return PX_ObjectCreateEx(mp, parent, x, y, z, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, PX_OBJECT_MAP_SIZE * PX_OBJECT_CELL_PIXELS, 0, 0, 0, PX_Object_MapRender, 0, &map, sizeof(map));
}

PX_OBJECT_MAP_CELL PX_Object_MapGetCell(PX_Object* pObject, px_int x, px_int y)
{
	PX_Object_Map* pdesc = PX_ObjectGetDesc(PX_Object_Map, pObject);
	if (x>=0&&x< PX_OBJECT_MAP_SIZE)
	{
		if (y >= 0 && y < PX_OBJECT_MAP_SIZE)
		{
			return pdesc->cells[x][y];
		}
	}
	return PX_OBJECT_MAP_CELL_BLACK;
	
}

px_void PX_Object_MapMark(PX_Object* pObject, px_int x, px_int y, px_int type)
{
	PX_Object_Map* pdesc = PX_ObjectGetDesc(PX_Object_Map, pObject);
	if (PX_Object_MapGetCell(pObject,x,y)==PX_OBJECT_MAP_CELL_NONE)
	{
		pdesc->cells[x][y] = type;
	}
}

px_float PX_Object_MapIndexToCoordinate(px_int i)
{
	return i * PX_OBJECT_CELL_PIXELS + PX_OBJECT_CELL_PIXELS / 2.f;
}

