#ifndef PX_OBJECT_MAP_H
#define PX_OBJECT_MAP_H
#include "PainterEngine_Startup.h"

#define  PX_OBJECT_MAP_Z 16
#define  PX_OBJECT_MAP_SIZE 16
#define  PX_OBJECT_CELL_PIXELS 48


typedef enum 
{
	PX_OBJECT_MAP_CELL_NONE=0,
	PX_OBJECT_MAP_CELL_RED=1,
	PX_OBJECT_MAP_CELL_BLUE=2,
	PX_OBJECT_MAP_CELL_BLACK=3,
	PX_OBJECT_MAP_CELL_WALL,
}PX_OBJECT_MAP_CELL;


typedef struct 
{
	PX_OBJECT_MAP_CELL  cells[PX_OBJECT_MAP_SIZE][PX_OBJECT_MAP_SIZE];
}PX_Object_Map;


PX_Object* PX_Object_MapCreate(px_memorypool* mp, PX_Object* parent, px_float x, px_float y,px_float z);
PX_OBJECT_MAP_CELL PX_Object_MapGetCell(PX_Object* pMap, px_int x, px_int y);
px_void PX_Object_MapMark(PX_Object* pMap, px_int x, px_int y, px_int type);
px_float PX_Object_MapIndexToCoordinate(px_int i);
#endif