#include "PX_Object_Match.h"

px_void PX_Object_MatchOnRender(px_surface* psurface, PX_Object* pObject, px_dword elapsed)
{
	px_float x, y, w, h;
	PX_Object_Match* pdesc = PX_ObjectGetDesc(PX_Object_Match, pObject);
	PX_OBJECT_INHERIT_CODE(pObject, x, y, w, h);
	pdesc->image.limit_right = (px_int)w;
	pdesc->image.limit_bottom = (px_int)h;
	PX_TextureRender(psurface, &pdesc->image, (px_int)x, (px_int)y, PX_ALIGN_LEFTTOP, 0);

}

px_void PX_Object_MatchOnFree(PX_Object* pObject)
{
	PX_Object_Match* pdesc = PX_ObjectGetDesc(PX_Object_Match, pObject);
	PX_TextureFree(&pdesc->image);
}
#ifdef _WIN64
#include "windows.h"
#endif
px_void PX_Object_MatchOnClick(PX_Object* pObject, PX_Object_Event e, px_void* ptr)
{
	PX_Object_Match *pdesc = PX_ObjectGetDesc(PX_Object_Match, pObject);
	if (!PX_ObjectIsCursorInRegion(pObject,e))
	{
		return;
	}

#ifdef _WIN64
	system("start https://www.painterengine.com");
#endif
}


PX_Object* PX_Object_MatchCreate(px_memorypool* mp, PX_Object* parent, px_float x, px_float y, px_float w, px_float h, PX_Json* language, PX_Json* config, PX_FontModule* fm)
{
	PX_Object_Match* pdesc;
	PX_Object* pObject;
	pObject=PX_ObjectCreateEx(mp, parent, x, y, 0, w, h, 0, 0, 0, PX_Object_MatchOnRender, 0, 0, sizeof(PX_Object_Match));
	pdesc = PX_ObjectGetDesc(PX_Object_Match, pObject);
	if (!PX_LoadTextureFromFile(mp, &pdesc->image, "assets/match.png"))
	{
		PX_ObjectDelete(pObject);
		return 0;
	}
	PX_ObjectRegisterEvent(pObject, PX_OBJECT_EVENT_CURSORDOWN, PX_Object_MatchOnClick, 0);
	return pObject;
}

