#include "PX_Object_Rank.h"

px_void PX_Object_RankListItemOnRender(px_surface* psurface, PX_Object* pObject, px_dword elapsed)
{
	PX_Object* pRankObject = pObject->User_ptr;
	PX_GameInstanceData* pdata = PX_Object_ListItemGetData(pObject);
	px_int index = PX_Object_ListItemGetIndex(pObject);
	PX_Object_Rank* pdesc = PX_ObjectGetDesc(PX_Object_Rank, pRankObject);
	px_texture staticTex = { 0 };
	px_char content[256] = {0};

	if (index==0)
	{
		PX_TextureRender(psurface, &pdesc->rank1, (px_int)(pObject->x + 8 + pdesc->rank1.width / 2), (px_int)(pObject->y + pObject->Height / 2), PX_ALIGN_CENTER,0);
	}
	else
	if (index == 1)
	{
		PX_TextureRender(psurface, &pdesc->rank2, (px_int)(pObject->x + 8 + pdesc->rank1.width / 2), (px_int)(pObject->y + pObject->Height / 2), PX_ALIGN_CENTER,0);
	}
	else
	if (index == 2)
	{
		PX_TextureRender(psurface, &pdesc->rank3, (px_int)(pObject->x + 8 + pdesc->rank1.width / 2), (px_int)(pObject->y + pObject->Height / 2), PX_ALIGN_CENTER,0);
	}
	else
	{
		px_color clr;
		px_int x, y;
		if (index<10)
		{
			clr = PX_COLOR(255, 255, 255, 0);
		}
		else if (index < 20)
		{
			clr = PX_COLOR(255, 0, 255, 255);
		}
		else if (index<30)
		{
			clr = PX_COLOR(255, 255, 0, 255);
		}
		else
		{
			clr = PX_OBJECT_UI_DEFAULT_FONTCOLOR;
		}
		PX_itoa(index+1, content, sizeof(content), 10);
		x = (px_int)(pObject->x + 8 + pdesc->rank1.width / 2);
		y = (px_int)(pObject->y + pObject->Height / 2);
		PX_GeoDrawBorder(psurface, x - 19, y - 19, x + 19, y + 19, 1, clr);
		PX_FontModuleDrawText(psurface, pdesc->fm, x, y, PX_ALIGN_CENTER,content,clr);
	}

	staticTex.height = 48;
	staticTex.limit_bottom = 47;
	staticTex.limit_right = 47;
	staticTex.MP = 0;
	staticTex.width = 48;
	staticTex.surfaceBuffer = (px_color *)pdata->profile_data;
	
	PX_TextureRender(psurface, &staticTex, (px_int)(pObject->x + 8 + pdesc->rank1.width+ staticTex.width/2 +10), (px_int)(pObject->y + pObject->Height / 2), PX_ALIGN_CENTER, 0);

	PX_sprintf6(content, sizeof(content), PX_JsonGetString(pdesc->language, "rank.info"), \
		PX_STRINGFORMAT_STRING(pdata->name),
		PX_STRINGFORMAT_STRING(pdata->author),
		PX_STRINGFORMAT_INT(pdata->win),
		PX_STRINGFORMAT_INT(pdata->match),
		pdata->match ? PX_STRINGFORMAT_FLOAT(pdata->win * 100.0f / pdata->match) : PX_STRINGFORMAT_FLOAT(0),
		PX_STRINGFORMAT_FLOAT(pdata->score)
	);
	
	
	PX_FontModuleDrawText(psurface, pdesc->fm, (px_int)(pObject->x + 8 + pdesc->rank1.width+ staticTex.width + 20), (px_int)(pObject->y + pObject->Height / 2), PX_ALIGN_LEFTMID, content, PX_OBJECT_UI_DEFAULT_FONTCOLOR);
}

px_bool PX_Object_RankListItemOnCreate(px_memorypool* mp, PX_Object* ItemObject, px_void* userptr)
{
	PX_Object* pObject = (PX_Object*)userptr;
	ItemObject->Func_ObjectRender = PX_Object_RankListItemOnRender;
	ItemObject->User_ptr = userptr;
	return PX_TRUE;
}

px_void PX_Object_RankOnButtonRefresh(PX_Object* pObject, PX_Object_Event e,px_void* ptr)
{
	PX_Object* pRankObject = (PX_Object*)ptr;
	PX_ObjectExecuteEvent(pRankObject->pParent, PX_OBJECT_BUILD_EVENT(PX_OBJECT_RANK_EVENT_REFRESH));
}

px_void PX_Object_RankOnButtonObserver(PX_Object* pObject, PX_Object_Event e, px_void* ptr)
{
	PX_Object* pRankObject = (PX_Object*)ptr;
	PX_Object_Rank *pdesc = PX_ObjectGetDesc(PX_Object_Rank, pRankObject);
	px_int index = PX_Object_ListGetCurrentSelectIndex(pdesc->list_rank);
	px_int count = PX_GameInstanceDataGetCount();
	if (index>=0&&index<count)
	{
		*PX_GameInstanceDataGetLocalPtr() = PX_GameInstanceDataGetPtr()[index];
		PX_ObjectExecuteEvent(pRankObject->pParent, PX_OBJECT_BUILD_EVENT(PX_OBJECT_RANK_EVENT_JOIN));
	}
	else
	{
		PX_Object_MessageBoxAlertOk(pdesc->messagebox, PX_JsonGetString(pdesc->language, "rank.choose observer"), 0, 0);
	}
}

PX_Object* PX_Object_RankCreate(px_memorypool* mp, PX_Object* parent, px_float x, px_float y, px_float w, px_float h, PX_Json* language, PX_Json* config, PX_FontModule* fm)
{
	PX_Object_Rank desc = { 0 }, * pdesc;
	PX_Object* pObject = PX_ObjectCreateEx(mp, parent, x, y, 0, w, h, 0, 0, 0, 0, 0, &desc, sizeof(desc));
	pdesc = PX_ObjectGetDesc(PX_Object_Rank, pObject);
	pdesc->mp = mp;
	pdesc->fm = fm;
	pdesc->config = config;
	pdesc->language = language;

	pdesc->list_rank = PX_Object_ListCreate(mp, pObject, 0, 0, 1, 1, 52, PX_Object_RankListItemOnCreate, pObject);
	pdesc->messagebox = PX_Object_MessageBoxCreate(mp, pObject, fm);
	pdesc->pushbutton_observe = PX_Object_PushButtonCreate(mp, pObject, 0, 0, 128, 32, PX_JsonGetString(language, "rank.observe"), fm);
	pdesc->pushbutton_refresh = PX_Object_PushButtonCreate(mp, pObject, 0, 0, 128, 32, PX_JsonGetString(language, "rank.refresh"), fm);
	PX_ObjectRegisterEvent(pdesc->pushbutton_refresh, PX_OBJECT_EVENT_EXECUTE, PX_Object_RankOnButtonRefresh, pObject);
	PX_ObjectRegisterEvent(pdesc->pushbutton_observe, PX_OBJECT_EVENT_EXECUTE, PX_Object_RankOnButtonObserver, pObject);

	pdesc->list_rank->x = 5;
	pdesc->list_rank->y = 5;
	pdesc->list_rank->Width = w - 10.f;
	pdesc->list_rank->Height = h - 10.f - pdesc->pushbutton_observe->Height - 10.f;

	pdesc->pushbutton_observe->x = w - pdesc->pushbutton_observe->Width - 10.f;
	pdesc->pushbutton_observe->y = h - pdesc->pushbutton_observe->Height - 10.f;

	pdesc->pushbutton_refresh->x = pdesc->pushbutton_observe->x - pdesc->pushbutton_refresh->Width - 10.f;
	pdesc->pushbutton_refresh->y = pdesc->pushbutton_observe->y;

	PX_LoadTextureFromFile(mp, &pdesc->rank1, "assets/rank1.png");
	PX_LoadTextureFromFile(mp, &pdesc->rank2, "assets/rank2.png");
	PX_LoadTextureFromFile(mp, &pdesc->rank3, "assets/rank3.png");

	return pObject;
}

px_void PX_Object_RankRefresh(PX_Object* pObject)
{
	PX_Object_Rank *pdesc = PX_ObjectGetDesc(PX_Object_Rank, pObject);
	PX_GameInstanceData* pdata = PX_GameInstanceDataGetPtr();
	px_int count = PX_GameInstanceDataGetCount();
	px_int i;
	PX_Object_ListClear(pdesc->list_rank);
	
	for (i=0;i<count;i++)
	{
		PX_Object_ListAdd(pdesc->list_rank, pdata + i);
	}

}
