#ifndef PX_OBJECT_ROBOT_H
#define PX_OBJECT_ROBOT_H
#include "PX_Object_Map.h"
#include "PX_Object_Missile.h"
#include "PX_Object_GameExplosion.h"
#include "PX_GameInstanceData.h"

#define PX_OBJECT_ROBOT_Z 12
#define PX_OBJECT_IMPACT_TYPE 1
#define PX_OBJECT_IMPACT_TARGET_TYPE 1
#define PX_OBJECT_ROBOT_GLOBAL_SIZE 1024
#define PX_OBJECT_ROBOT_STACK_SIZE 256
#define PX_OBJECT_ROBOT_MISSILE_SPEED (PX_OBJECT_CELL_PIXELS*3)
typedef enum 
{
	PX_OBJECT_ROBOT_TYPE_RED=1,
	PX_OBJECT_ROBOT_TYPE_BLUE=2,
}PX_OBJECT_ROBOT_TYPE;

typedef struct 
{
	PX_World *pworld;
	px_point2D velocity;
	px_point2D direction;
	px_memorypool* mp;
	PX_OBJECT_ROBOT_TYPE type;
	PX_FontModule* fm;
	PX_VM vm;
	PX_Object* map;
	PX_GameInstanceData data;
	px_uint64 vm_seed;
	px_dword vm_elapsed,breath_elapsed,launch_elapsed;
	px_bool death;
	PX_Runtime* pruntime;

}PX_Object_Robot;

const px_char* PX_Object_RobotGetStdlib();

PX_Object* PX_Object_RobotCreate(px_memorypool* mp, PX_Runtime* pruntime, PX_Object* parent, px_float x, px_float y,PX_World *pworld, PX_OBJECT_ROBOT_TYPE type, PX_GameInstanceData* pdata, PX_Object* map, PX_FontModule* fm);
#endif
