#include "PX_Object_Server.h"

px_void PX_Object_ServerFree(PX_Object* pObject)
{
	PX_Object_Server* pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
	pdesc->run = 0;
	return;
}

px_void PX_Object_ServerRecordScore(PX_Object* pObject)
{
	PX_Object_Server* pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
	px_int i;

	if (pdesc->run_score)
	{
		printf("update score\n");
		for (i = 0; i < pdesc->instance_count; i++)
		{
			pdesc->instance[i].score *= 0.99f;

			if (i == 0)
			{
				pdesc->instance[i].score += 100;
			}
			else if (i == 1)
			{
				pdesc->instance[i].score += 80;
			}
			else if (i == 2)
			{
				pdesc->instance[i].score += 60;
			}
			else if (i < 10)
			{
				pdesc->instance[i].score += 50;
			}
			else if (i < 20)
			{
				pdesc->instance[i].score += 30;
			}
			else if (i < 30)
			{
				pdesc->instance[i].score += 20;
			}
			//save data
			do
			{
				px_char filename[260];
				PX_sprintf1(filename, sizeof(filename), "database/%1", PX_STRINGFORMAT_STRING(pdesc->instance[i].key));
				pdesc->instance[i].crc32 = PX_crc32(&pdesc->instance[i], sizeof(pdesc->instance[i]) - 4);
				PX_SaveDataToFile(&pdesc->instance[i], sizeof(pdesc->instance[i]), filename);
			} while (0);

		}
	}

	
	pdesc->sum32 = PX_sum32(pdesc->instance, pdesc->instance_count * sizeof(PX_GameInstanceData));

}

px_void PX_Object_ServerTransferAllPlayerData(PX_Object* pObject)
{
	PX_Object_Server* pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
	px_int i;

	px_int fcount = PX_FileGetDirectoryFileCount("database", PX_FILEENUM_TYPE_FILE, 0);
	px_char filename[PX_GAMEINSTANCEDATA_MAX][260];


	if (fcount > PX_GAMEINSTANCEDATA_MAX) fcount = PX_GAMEINSTANCEDATA_MAX;
	PX_FileGetDirectoryFileName("database", fcount, filename, PX_FILEENUM_TYPE_FILE, 0);
	pdesc->instance_count = 0;
	for (i = 0; i < fcount; i++)
	{
		px_char path[260];
		PX_IO_Data io;
		PX_sprintf1(path, sizeof(path), "database/%1", PX_STRINGFORMAT_STRING(filename[i]));
		io = PX_LoadFileToIOData(path);
		if (io.size == sizeof(PX_GameInstanceDataOld))
		{
			PX_GameInstanceDataOld old = *(PX_GameInstanceDataOld*)io.buffer;
			PX_GameInstanceData newdata = { 0 };
			PX_FreeIOData(&io);

			PX_memcpy(newdata.author, old.author, sizeof(old.author));
			PX_memcpy(newdata.bin, old.bin, sizeof(old.bin));
			PX_memcpy(&newdata.binsize, &old.binsize, sizeof(old.binsize));
			PX_memcpy(newdata.code, old.code, sizeof(old.code));
			PX_memcpy(newdata.key, old.key, sizeof(old.key));
			PX_memcpy(&newdata.match, &old.match, sizeof(old.match));
			PX_memcpy(newdata.name, old.name, sizeof(old.name));
			PX_memcpy(newdata.profile_data, old.profile_data, sizeof(old.profile_data));
			PX_memcpy(&newdata.win, &old.win, sizeof(old.win));
			newdata.crc32 = PX_crc32(&newdata, sizeof(newdata) - 4);
			printf("transfer:%s\n", old.key);
			PX_SaveDataToFile(&newdata, sizeof(newdata), path);
		}

	}


}

px_void PX_Object_ServerReloadAllPlayerData(PX_Object* pObject)
{
	PX_Object_Server* pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
	px_int i, j, k;

	px_int fcount = PX_FileGetDirectoryFileCount("database", PX_FILEENUM_TYPE_FILE, 0);
	px_char filename[PX_GAMEINSTANCEDATA_MAX][260];

	printf("reload data\n");
	//server control
	pdesc->run = PX_FALSE;

	if (fcount > PX_GAMEINSTANCEDATA_MAX) fcount = PX_GAMEINSTANCEDATA_MAX;
	PX_FileGetDirectoryFileName("database", fcount, filename, PX_FILEENUM_TYPE_FILE, 0);
	pdesc->instance_count = 0;
	for (i = 0; i < fcount; i++)
	{
		px_char path[260];
		PX_IO_Data io;
		PX_sprintf1(path, sizeof(path), "database/%1", PX_STRINGFORMAT_STRING(filename[i]));
		io = PX_LoadFileToIOData(path);
		if (io.size == sizeof(PX_GameInstanceData))
		{
			PX_GameInstanceData* pInstance = (PX_GameInstanceData*)io.buffer;
			if (PX_crc32(io.buffer, io.size - 4) == pInstance->crc32)
			{
				PX_memcpy(&pdesc->instance[pdesc->instance_count], io.buffer, sizeof(PX_GameInstanceData));
				do
				{
					px_char content[64];
					PX_sprintf2(content, sizeof(content), "load instance:%1 with key %2", PX_STRINGFORMAT_STRING(pdesc->instance[pdesc->instance_count].name), PX_STRINGFORMAT_STRING(filename[i]));
					PX_memset(pdesc->instance[pdesc->instance_count].key, 0, sizeof(pdesc->instance[pdesc->instance_count].key));
					PX_strcpy(pdesc->instance[pdesc->instance_count].key, filename[i], sizeof(pdesc->instance[pdesc->instance_count].key));
					PX_Object_PrinterPrintText(pdesc->printer, content);

				} while (0);
				pdesc->instance_count++;

			}
			PX_FreeIOData(&io);
		}

	}

	//server control
	pdesc->run = PX_TRUE;

	//sort
	for (k = 0; k < pdesc->instance_count; k++)
	{
		for (j = pdesc->instance_count - 1; j > k; j--)
		{
			px_float wr1 = pdesc->instance[j].match == 0 ? 0 : pdesc->instance[j].win * 1.0f / pdesc->instance[j].match;
			px_float wr2 = pdesc->instance[j - 1].match == 0 ? 0 : pdesc->instance[j - 1].win * 1.0f / pdesc->instance[j - 1].match;
			if (wr1 > wr2)
			{
				PX_GameInstanceData tmp = pdesc->instance[j];
				pdesc->instance[j] = pdesc->instance[j - 1];
				pdesc->instance[j - 1] = tmp;
			}
		}
	}

	pdesc->sum32 = PX_sum32(pdesc->instance, pdesc->instance_count * sizeof(PX_GameInstanceData));

}


px_void PX_Object_ServerUpdate(PX_Object* pObject, px_dword elapsed)
{
	PX_Object_Server* pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
	px_int i;
	for (i=0;i< PX_OBJECT_SERVER_MAX_HANDLE;i++)
	{
		if (pdesc->connection[i].addr.ipv4)
		{
			pdesc->connection[i].last_connect_elapsed += elapsed;
			if (pdesc->connection[i].last_connect_elapsed >2100)
			{
				pdesc->connection[i].last_connect_elapsed = 0;
				PX_memset(&pdesc->connection[i], 0, sizeof(pdesc->connection[i]));
			}
		}
	}
	pdesc->uptodate_elapsed += elapsed;
	if (pdesc->uptodate_elapsed >= PX_OBJECT_SERVER_UPTODATE_DURATION)
	{
		if (pdesc->needUpdate)
		{
			pdesc->uptodate_elapsed = 0;
			pdesc->needUpdate = 0;
			PX_Object_ServerDateUpToDate(pObject);
		}
		
	}

	pdesc->reload_elapsed += elapsed;
	if (pdesc->reload_elapsed>=PX_OBJECT_SERVER_RELOAD_DURATION)
	{
		
		if (PX_Object_ServerDataGetState()==PX_OBJECT_SERVERDATA_STATE_STANDBY)
		{
			pdesc->reload_elapsed = 0;
			PX_Object_ServerReloadAllPlayerData(pObject);
		}
	}

	pdesc->score_elapsed += elapsed;
	if (pdesc->score_elapsed>=PX_OBJECT_SERVER_SCORE_DURATION)
	{
		if (PX_Object_ServerDataGetState() == PX_OBJECT_SERVERDATA_STATE_STANDBY)
		{
			pdesc->score_elapsed = 0;
			PX_Object_ServerRecordScore(pObject);
		}
	}
}



px_void PX_Object_ServerHandleConnection(px_void* ptr)
{
	PX_Object_ServerConnection *con = (PX_Object_ServerConnection*)ptr;
	PX_Object* pObject = (PX_Object*)con->pServerObject;
	PX_Object_Server* pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
	
	
	px_byte opcode;
	
	//handshake
	do
	{
		px_int i;
		
		PX_AES ase;
		px_byte ase_encrypt_code[16];
		px_byte input[16], output[16];
		for (i = 0; i < 16; i++)
		{
			ase_encrypt_code[i] = PX_rand() % 0xff;
		}
		PX_memcpy(ase_encrypt_code, pdesc->version, 8);

		PX_AES_Initialize(&ase, PX_AES_KeySize_Bits128, ase_encrypt_code);
		if (!PX_TCPSocketSend(con->socket, ase_encrypt_code, 16))
		{
			printf("socket hand-shake error\n");
			goto _END;
		}
		if (PX_TCPSocketReceived(con->socket, input, 16, 1800) != 16)
		{
			printf("socket hand-shake error\n");
			goto _END;
		}
		con->last_connect_elapsed = 0;
		PX_AES_InvCipher(&ase, input, output);
		opcode = output[0];
		for (i = 1; i < 16; i++)
		{
			if (output[i] != 0)
			{
				goto _END;
			}
		}
		if (opcode==1)
		{
			px_dword Response = 0;
			if (!PX_TCPSocketSend(con->socket, &Response, sizeof(Response)))
			{
				goto _END;
			}
				
		}
		else if (opcode==0)
		{
			px_dword Response[2] ;
			Response[0] = pdesc->instance_count;
			Response[1] = pdesc->sum32;
			if (!PX_TCPSocketSend(con->socket, Response, sizeof(Response)))
			{
				goto _END;
			}
		}
		else
		{
			goto _END;
		}
		
		
	} while (0);


	if (opcode==0)//read
	{

		while (1)
		{
			px_dword index;
			if (PX_TCPSocketReceived(con->socket, &index, 4, 1800) != 4)
			{
				goto _END;
			}
			con->last_connect_elapsed = 0;
			if ((px_int)index<pdesc->instance_count)
			{
				px_int try = 5;
				PX_GameInstanceData sendinstance = pdesc->instance[index];
				PX_memset(sendinstance.key, 0, sizeof(sendinstance.key));
				PX_memset(sendinstance.code, 0, sizeof(sendinstance.code));
				if (!PX_TCPSocketSend(con->socket, &sendinstance, sizeof(PX_GameInstanceData)))
				{
					goto _END;
				}
			}
			else
			{
				//printf("succeeded read from:%s\n", (const px_char*)PX_inet_ntoa(con->addr.ipv4).data);
				goto _END;
			}
		}
	}
	else if(opcode==1)//write
	{
		PX_GameInstanceData data = {0};

		//data
		do
		{
			px_dword response = 0;
			px_int i;

			if (PX_TCPSocketReceived(con->socket,&data, sizeof(data),1800)!= sizeof(data))
			{
				goto _END;
			}
			con->last_connect_elapsed = 0;
			if (data.author[PX_GAMEINSTANCEDATA_CONTENT_SIZE-1]!=0)
			{
				goto _END;
			}
			if (data.key[PX_GAMEINSTANCEDATA_CONTENT_SIZE - 1] != 0)
			{
				goto _END;
			}
			if (data.name[PX_GAMEINSTANCEDATA_CONTENT_SIZE - 1] != 0)
			{
				goto _END;
			}

			for ( i = 0; i < pdesc->keys.size; i++)
			{
				if (PX_strequ(data.key,PX_VECTORAT(PX_Object_ServerKeys,&pdesc->keys,i)->key))
				{
					break;
				}
			}

			if (i==pdesc->keys.size)
			{
				response = 1;
				PX_TCPSocketSend(con->socket, &response, 4);
				goto _END;
			}
			
		} while (0);


		do 
		{
			px_byte cache[1024 * 512];
			px_memory bin;
			px_memorypool mp = MP_Create(cache, sizeof(cache));
			PX_Compiler compiler;
			px_int i;
			px_dword response = 0;
			PX_SCRIPT_ASM_HEADER* pheader;
			PX_MemoryInitialize(&mp, &bin);
			PX_CompilerInitialize(&mp, &compiler);
			PX_CompilerAddSource(&compiler, PX_Object_RobotGetStdlib());
			PX_CompilerAddSource(&compiler, (const px_char *)data.code);
			if (!PX_CompilerCompile(&compiler, &bin, 0, "main"))
			{
				goto _END;
			}
			pheader = (PX_SCRIPT_ASM_HEADER*)bin.buffer;
			if (pheader->stringSize != 0 || pheader->memsize != 0)
			{
				goto _END;
			}
			if (pheader->globalsize> PX_OBJECT_ROBOT_GLOBAL_SIZE)
			{
				goto _END;
			}
			if (pheader->stacksize > PX_OBJECT_ROBOT_STACK_SIZE)
			{
				goto _END;
			}
			if (bin.usedsize>sizeof(data.bin))
			{
				goto _END;
			}
			PX_memcpy(data.bin, bin.buffer, bin.usedsize);
			data.binsize = bin.usedsize;

			for (i = 0; i < pdesc->instance_count; i++)
			{
				if (PX_strequ(pdesc->instance[i].key, data.key))
				{
					px_float score = pdesc->instance[i].score;
					pdesc->instance[i] = data;
					pdesc->instance[i].score = score;
					data.score = score;
					break;
				}
			}
			if (i==pdesc->instance_count)
			{
				data.score = 0;
				data.win = 0;
				data.match = 0;
				pdesc->instance[pdesc->instance_count] = data;
				pdesc->instance_count++;
				pdesc->sum32 = PX_sum32(pdesc->instance, pdesc->instance_count * sizeof(PX_GameInstanceData));
			}

			//save data
			do 
			{
				px_char filename[260];
				PX_sprintf1(filename, sizeof(filename), "database/%1", PX_STRINGFORMAT_STRING(data.key));
				data.match = 0;
				data.win = 0;
				data.crc32 = PX_crc32(&data, sizeof(data) - 4);
				PX_SaveDataToFile(&data, sizeof(data), filename);
			} while (0);

			response = 0;
			if (!PX_TCPSocketSend(con->socket, &response, 4))
				goto _END;

			pdesc->needUpdate = 1;
			printf("client:%s push new codes\n", data.author);
		} while (0);
	}
	else
	{
		goto _END;
	}


_END:
	printf("close client connection:%s\n", (const px_char *)PX_inet_ntoa(con->addr.ipv4).data);
	PX_TCPSocketFree(con->socket);
	con->socket = 0;
	return;
}

px_void PX_Object_ServerListenThread(px_void* ptr)
{
	PX_Object* pObject = (PX_Object*)ptr;
	PX_Object_Server *pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
	while (1)
	{
		if (!pdesc->run)
		{
			PX_Sleep(1000);
			continue;
		}
		px_uint socket;
		PX_TCP_ADDR addr;
		if (PX_TCPAccept(&pdesc->tcp, &socket, &addr))
		{
			px_int i;
			if (!pdesc->run)
			{
				PX_TCPSocketFree(socket);
				continue;
			}
			printf("new connection from %s\n", PX_inet_ntoa(addr.ipv4).data);

			for (i=0;i< PX_OBJECT_SERVER_MAX_HANDLE;i++)
			{
				if (pdesc->connection[i].addr.ipv4 == addr.ipv4)
				{
					PX_TCPSocketFree(socket);
					printf("close connection from %s\n", PX_inet_ntoa(addr.ipv4).data);
					break;
				}
			}
			if (i== PX_OBJECT_SERVER_MAX_HANDLE)
			{
				px_dword max = 0;
				px_int index=0;
				for (i = 0; i < PX_OBJECT_SERVER_MAX_HANDLE; i++)
				{
					if (pdesc->connection[i].addr.ipv4 == 0)
					{
						pdesc->connection[i].addr = addr;
						pdesc->connection[i].last_connect_elapsed = 0;
						pdesc->connection[i].socket = socket;
						pdesc->connection[i].pServerObject = pObject;
						if (!PX_ThreadCreate(&pdesc->connection[i].thread, PX_Object_ServerHandleConnection,&pdesc->connection[i]))
						{
							PX_memset(&pdesc->connection[i], 0, sizeof(pdesc->connection[i]));
						}
						break;
					}
				}

				if (i== PX_OBJECT_SERVER_MAX_HANDLE)
				{
					printf("close connection from %s for MAX_HANDLE\n", PX_inet_ntoa(addr.ipv4).data);
                    PX_TCPSocketFree(socket);
				}

			}
		}
	}
}



PX_Object* PX_Object_ServerCreate(px_memorypool* mp, PX_Object* parent, px_float x, px_float y, px_float width, px_float height, PX_Json* pconfig,PX_FontModule *fm)
{
	PX_Object* pObject;
	PX_Object_Server *pdesc;
	px_int listen;
	px_int i;

	pObject=PX_ObjectCreateEx(mp, parent, x, y, 0, width, height, 0, 0, PX_Object_ServerUpdate, 0, PX_Object_ServerFree,  0, sizeof(PX_Object_Server));
	

	if (!pObject)
	{
		return 0;
	}
	else
	{
		pdesc = PX_ObjectGetDesc(PX_Object_Server, pObject);
		pdesc->fm = fm;
		pdesc->mp = mp;
		pdesc->printer = PX_Object_PrinterCreate(mp, pObject, 0, 0, (px_int)width, (px_int)height, fm);
		pdesc->needUpdate = PX_TRUE;
		pdesc->uptodate_elapsed = 0;
		if (PX_JsonGetBoolean(pconfig,"server.enable"))
		{
			//////////////////////////////////////////////////////////////////////////
		//keys
			do
			{
				px_int i;
				px_int count;
				PX_Json_Value* pKeysArray = PX_JsonGetValue(pconfig, "keys");
				PX_VectorInitialize(mp, &pdesc->keys, sizeof(PX_Object_ServerKeys), 1024);
				if (pKeysArray->type != PX_JSON_VALUE_TYPE_ARRAY)
				{
					return 0;
				}
				count = pKeysArray->_array.size;
				PX_Object_PrinterPrintText(pdesc->printer, "Load keys:");
				for (i = 0; i < count; i++)
				{

					px_char payload[16];
					PX_Json_Value* pArrayData;
					PX_sprintf1(payload, sizeof(payload), "keys[%1].key", PX_STRINGFORMAT_INT(i));
					pArrayData = PX_JsonGetValue(pconfig, payload);
					if (pArrayData && pArrayData->type == PX_JSON_VALUE_TYPE_STRING)
					{
						PX_Object_ServerKeys key = { 0 };
						PX_strcat(key.key, pArrayData->_string.buffer);
						PX_VectorPushback(&pdesc->keys, &key);
						PX_Object_PrinterPrintText(pdesc->printer, key.key);
					}

				}

			} while (0);

			pdesc->run_score = PX_JsonGetBoolean(pconfig, "server.run score");
			if (pdesc->run_score)
			{
				PX_Object_PrinterPrintText(pdesc->printer, "run score true");
			}
			

			pdesc->clear_score = PX_JsonGetBoolean(pconfig, "server.clear score");
			if (pdesc->clear_score)
			{
				PX_Object_PrinterPrintText(pdesc->printer, "clear score true");
			}


			//////////////////////////////////////////////////////////////////////
			//transfer
			PX_Object_ServerTransferAllPlayerData(pObject);


			//////////////////////////////////////////////////////////////////////////
			//read data
			PX_Object_PrinterPrintText(pdesc->printer, "server up-to-date...");
			PX_Object_ServerReloadAllPlayerData(pObject);


			//////////////////////////////////////////////////////////////////////////
			//clear score
			if (pdesc->clear_score)
			{
				pdesc->clear_score = PX_FALSE;
				for (i = 0; i < pdesc->instance_count; i++)
				{
					pdesc->instance[i].score = 0;
					//save data
					do
					{
						px_char filename[260];
						PX_sprintf1(filename, sizeof(filename), "database/%1", PX_STRINGFORMAT_STRING(pdesc->instance[i].key));
						pdesc->instance[i].crc32 = PX_crc32(&pdesc->instance[i], sizeof(pdesc->instance[i]) - 4);
						PX_SaveDataToFile(&pdesc->instance[i], sizeof(pdesc->instance[i]), filename);
					} while (0);

				}
			}



			//version
			pdesc->version[0] = 0;
			PX_strset(pdesc->version,PX_JsonGetString(pconfig, "server.version"));
			PX_Object_PrinterPrintText(pdesc->printer, "version:");
			PX_Object_PrinterPrintText(pdesc->printer, pdesc->version);


			//enable server
			if (!PX_TCPInitialize(&pdesc->tcp, PX_TCP_IP_TYPE_IPV4))
			{
				PX_Object_PrinterPrintText(pdesc->printer, "Socket initialized error");
				printf("socket initialize error!\n");
				goto _END;
			}
			PX_Object_PrinterPrintText(pdesc->printer, "server socket initialize succeed.");

			listen = (px_int)PX_JsonGetNumber(pconfig, "server.listen");
			if (listen == 0)
			{
				PX_Object_PrinterPrintText(pdesc->printer, "Socket initialized error");
				printf("socket initialize error!\n");
				return 0;
			}

			if (!PX_TCPListen(&pdesc->tcp, PX_htons(listen)))
			{
				PX_ObjectDelete(pObject);
				printf("listen error!\n");
				return 0;
			}
			PX_Object_PrinterPrintText(pdesc->printer, "server listening.");

			pdesc->run = PX_TRUE;
			if (!PX_ThreadCreate(&pdesc->thread, PX_Object_ServerListenThread, pObject))
			{
				PX_ObjectDelete(pObject);
				printf("thread error!\n");
				return 0;
			}

			PX_Object_PrinterPrintText(pdesc->printer, "server running...");
		}
		else
		{
			pObject->Enabled = PX_FALSE;
			PX_Object_PrinterPrintText(pdesc->printer, "local server closed...");
		}
	}
_END:
	return pObject;
}



