#include "PainterEngine_Startup.h"
#include "platform/modules/px_tcp.h"
#include "platform/modules/px_thread.h"
#include "PX_GameInstanceData.h"
#include "PX_Object_ServerData.h"
#include "PX_Game.h"

#define PX_OBJECT_SERVER_MAX_HANDLE 32
#define PX_OBJECT_SERVER_RELOAD_DURATION 60000
#define PX_OBJECT_SERVER_UPTODATE_DURATION 600000
#define PX_OBJECT_SERVER_SCORE_DURATION 1800000
typedef struct  
{
	PX_Object* pServerObject;
	PX_TCP_ADDR addr;
	volatile px_dword last_connect_elapsed;
	px_uint socket;
	px_thread thread;
}PX_Object_ServerConnection;

typedef struct  
{
	px_char key[PX_GAMEINSTANCEDATA_CONTENT_SIZE];
}PX_Object_ServerKeys;


typedef struct  
{
	PX_TCP tcp;
	px_memorypool* mp;
	px_thread thread;
	PX_Json *pconfig;
	volatile px_bool run;
	PX_Object_ServerConnection connection[PX_OBJECT_SERVER_MAX_HANDLE];
	PX_GameInstanceData instance[PX_GAMEINSTANCEDATA_MAX];
	px_int instance_count;
	PX_Object* printer;
	PX_FontModule* fm;
	px_vector keys;
	px_dword reload_elapsed;
	px_dword uptodate_elapsed;
	px_dword score_elapsed;
	px_bool needUpdate,run_score,clear_score;
	volatile px_dword sum32;
	px_char version[16];
}PX_Object_Server;


PX_Object* PX_Object_ServerCreate(px_memorypool *mp,PX_Object* parent, px_float x, px_float y, px_float width, px_float height, PX_Json *pconfig, PX_FontModule* fm);
px_void PX_Object_ServerReloadAllPlayerData(PX_Object* pObject);