#include "PX_Object_ServerData.h"

static PX_GameInstanceData g_instance[PX_GAMEINSTANCEDATA_MAX];
static px_int g_instance_count;
static px_byte g_runtime_buffer[1024 * 1024 * 12];
static px_thread thread = { 0 };
static px_uint64 g_seed;
volatile static PX_OBJECT_SERVERDATA_STATE state= PX_OBJECT_SERVERDATA_STATE_STANDBY;

px_void PX_Object_ServerDataUpdateAllPlayerData()
{
	px_int i;
	px_int j;
	px_memorypool mp = MP_Create(g_runtime_buffer, sizeof(g_runtime_buffer));
	
	for (i = 0; i < g_instance_count; i++)
	{
		g_instance[i].match = 0;
		g_instance[i].win = 0;
		g_seed = PX_randEx(g_seed);
		g_instance[i].seed= (px_dword)(g_seed & 0xffffffff);
	}
	printf("players data up-to-date\n");
	for (i = 0; i < g_instance_count - 1; i++)
	{
		for (j = i + 1; j < g_instance_count; j++)
		{
			PX_GAME_RESULT result;
			result = PX_GameRunTest(&mp, g_instance + i, g_instance + j);
			printf("players %d-%d data up-to-date\n", i, j);
			if (result == PX_GAME_RESULT_REDWIN)
			{
				g_instance[i].match++;
				g_instance[j].match++;
				g_instance[i].win++;
			}
			else if (result == PX_GAME_RESULT_BLUEWIN)
			{
				g_instance[i].match++;
				g_instance[j].match++;
				g_instance[j].win++;
			}
			else
			{
				g_instance[i].match++;
				g_instance[j].match++;
			}
		}
	}


	for (i = 0; i < g_instance_count; i++)
	{
		px_char path[260];
		PX_sprintf1(path, sizeof(path), "database/%1", PX_STRINGFORMAT_STRING(g_instance[i].key));
		g_instance[i].crc32 = PX_crc32(g_instance + i, sizeof(PX_GameInstanceData) - 4);
		PX_SaveDataToFile(&g_instance[i], sizeof(PX_GameInstanceData), path);
	}
}

px_dword PX_Object_ServerDataUpdate(px_void *ptr)
{
	px_int i;
	px_int fcount = PX_FileGetDirectoryFileCount("database", PX_FILEENUM_TYPE_FILE, 0);
	px_char filename[PX_GAMEINSTANCEDATA_MAX][260];
	if (fcount > PX_GAMEINSTANCEDATA_MAX) fcount = PX_GAMEINSTANCEDATA_MAX;
	PX_FileGetDirectoryFileName("database", fcount, filename, PX_FILEENUM_TYPE_FILE, 0);
	g_instance_count = 0;
	for (i = 0; i < fcount; i++)
	{
		px_char path[260];
		PX_IO_Data io;
		PX_sprintf1(path, sizeof(path), "database/%1", PX_STRINGFORMAT_STRING(filename[i]));
		io = PX_LoadFileToIOData(path);
		if (io.size == sizeof(PX_GameInstanceData))
		{
			PX_GameInstanceData* pInstance = (PX_GameInstanceData*)io.buffer;
			if (PX_crc32(io.buffer, io.size - 4) == pInstance->crc32)
			{
				PX_memcpy(&g_instance[g_instance_count], io.buffer, sizeof(PX_GameInstanceData));
				PX_memset(g_instance[g_instance_count].key, 0, sizeof(g_instance[g_instance_count].key));
				PX_strset(g_instance[g_instance_count].key, filename[i]);
				g_instance_count++;

			}
		}
		PX_FreeIOData(&io);
	}
	PX_Object_ServerDataUpdateAllPlayerData();
	state = PX_OBJECT_SERVERDATA_STATE_STANDBY;
	return 0;
}


px_void PX_Object_ServerDateUpToDate()
{
	g_seed+= PX_TimeGetTime() + PX_TimeGetSecond() + PX_TimeGetHour();
	if (state==PX_OBJECT_SERVERDATA_STATE_STANDBY)
	{
		state = PX_OBJECT_SERVERDATA_STATE_UPDATING;
		PX_ThreadCreate(&thread, PX_Object_ServerDataUpdate, 0);
	}
}

PX_OBJECT_SERVERDATA_STATE PX_Object_ServerDataGetState()
{
	return state;
}
